#define SIGEL_USE_ONLY

float ft;
//#define SIGEL_DEVIL
//#define SIGEL_SOUND
//#define SIGEL_SCRIPT
//#define SIGEL_PHYSX
//#define SIGEL_NETWORK

#include <sigel/ISigel.h>

unsigned int maxwidth;
unsigned int maxheight;

class Worm
{
	unsigned char r,g,b;

	float x,y;
	float dx,dy;
	float tx,ty;

	float sz;
//	static const int n = 100;
//	Vector3D sect[n];
public:
	Worm();
	void Update();
	void Draw();
};

Worm::Worm()
{
	r = rand(32,255);
	g = rand(32,255);
	b = rand(32,255);

	x = rand(0,maxwidth);
	y = rand(0,maxheight);

	tx = rand(0,maxwidth);
	ty = rand(0,maxheight);

	dx = 0;
	dy = 0;

	sz = 128;
}

void Worm::Update()
{
	if(Dist2D(x,y,tx,ty)<10)
	{
		tx = rand(0,maxwidth);
		ty = rand(0,maxheight);
	}

	Vector2D d(tx-x,ty-y);
	d.normalize();
	d*=0.02f;

	dx += d.x;
	dy += d.y;

	dx*=0.99f;
	dy*=0.99f;

	x+=dx*ft*0.03f;
	y+=dy*ft*0.03f;

}

void Worm::Draw()
{
	Color(r,g,b);
	DrawRect(x-sz,y-sz,sz*2,sz*2);

//	DrawCurve(n,sect);
}

sGAME
{
	debug::startlog();
	Init(800,600,32,2,0);
	AppTitle("FireFlyDemo");

	maxwidth = ScreenWidth();
	maxheight = ScreenHeight();

	VWait(0);
	CameraHelper ch;

	TFont *fnt = new TFont("tahoma.txt");

	Texture *rockwall = new Texture("rockwall.tga");
	Texture *rockwall_nrm = new Texture("rockwall_nrm.tga");

	Texture *firefly = new Texture("tmpi2.bmp");

	float maxu = maxwidth / 256.0f;
	float maxv = maxheight / 256.0f;

	TexSize rt(maxwidth,maxheight);
	Texture *colortex = new Texture(rt,3,GL_TEXTURE_RECTANGLE_ARB);
	Texture *normaltex = new Texture(rt,3,GL_TEXTURE_RECTANGLE_ARB);

	Shader *sh_render = new Shader("render");
	sh_render->WriteInt("colormap",0);
	sh_render->WriteInt("normalmap",1);

	Shader *sh_light = new Shader("light");
	sh_light->WriteInt("colormap",1);
	sh_light->WriteInt("normalmap",2);
	sh_light->WriteInt("lightmap",0);

	int maxcnt = 1000;
	Worm *wa = new Worm[maxcnt];

	Effect *fscnm = new Effect();
	fscnm->BindTexture(colortex,0);
	fscnm->BindTexture(normaltex,1);

	int cnt = 10;

	while(!KeyDown(VK_ESCAPE))
	{
		ft = GetFrameTime();
		//3d
		for(int i=0;i<cnt;++i)
		{
			wa[i].Update();
		}

		ch.Update();
		Render();
		//2d
		fscnm->Bind();
		sh_render->Bind();
		Blend(BM_NONE);
		rockwall->Bind(0);
		rockwall_nrm->Bind(1);
		DrawRectUV(0,0,maxwidth,maxheight,maxu,maxv);
		rockwall_nrm->UnBind();
		rockwall->UnBind();
		sh_render->UnBind();
		fscnm->UnBind();

		if(KeyHit('Z')==1 || KeyHit('Z')>100)
		{
			cnt--;
			if(cnt<0)
				cnt = 0;
		}

		if(KeyHit('X')==1 || KeyHit('X')>100)
		{
			cnt++;
			if(cnt>1000)
				cnt = 1000;
		}

		sh_light->Bind();
		firefly->Bind(0);
		colortex->Bind(1);
		normaltex->Bind(2);

		Blend(BM_ADD);
		for(int i=0;i<cnt;++i)
		{
			wa[i].Draw();
		}
		normaltex->UnBind();
		colortex->UnBind();
		firefly->UnBind();
		sh_light->UnBind();

		Color(255,255,255);
		fnt->Text(GetFPS(),10,10);
		fnt->Text(cnt,20,50);

		Flip();

//		Sleep(10);
	}

	DeInit();
	debug::endlog();
};